/*
 * Write_dtgrdFile_ASCII.h
 *
 *  Created on: Dec 16, 2011
 *      Author: oezboyma
 */

#ifndef WRITE_DTGRDFILE_ASCII_H_
#define WRITE_DTGRDFILE_ASCII_H_
#include <stdlib.h>
#include <iostream>
#include <list>
#include <fstream>
#include <string>
#include <sstream>
#include <math.h>
using namespace std;

int Write_dtgrdFile_ASCII(FILE *output_file, list<double>& Value,\
		list<int>& xcoord, list<int>& ycoord,list<int>& zcoord,\
		list<int>& acc, list<int>& acc2D, list<int>& acc3D,\
		list<int>& proj1D,list<int>& proj2D)
{
	int counter;
	list<double>::iterator itf;
	list<int>::iterator it;

	counter= 0;
	fprintf(output_file, "%d\n", (int) Value.size());
	for (itf = Value.begin(); itf != Value.end(); itf++){
		fprintf(output_file, "\t%E", *itf);
		counter++;
		if (counter == 6){
			fprintf(output_file, "\n");
			counter = 0;
		}
	}

	counter = 0;
	fprintf(output_file, "\n%d\n", (int) zcoord.size());
	for (it = zcoord.begin(); it != zcoord.end(); it++){
		fprintf(output_file, "\t%d", *it);
		counter++;
		if (counter == 12){
			fprintf(output_file, "\n");
			counter = 0;
		}
	}

	counter = 0;
	fprintf(output_file, "\n%d\n", (int) acc.size());
	for (it = acc.begin(); it != acc.end(); it++){
		fprintf(output_file, "\t%d", *it);
		counter++;
		if (counter == 12){
			fprintf(output_file, "\n");
			counter = 0;
		}
	}

	counter = 0;
	fprintf(output_file, "\n%d\n", ((int) proj1D.size())+2);
	for (it = proj1D.begin(); it != proj1D.end(); it++){
		if (fmod(counter,2) == 0)
			fprintf(output_file, "\t%d", *it);
		else
			fprintf(output_file, "\t%d", (*it)/2);
		counter++;
		if (counter == 12){
			fprintf(output_file, "\n");
			counter = 0;
		}
	}
	it--;
	it--;
	fprintf(output_file, "\t%d", *it);
	it++;
	fprintf(output_file, "\t%d", (*it)/2+1);

	counter = 0;
	fprintf(output_file, "\n%d\n", (int) ycoord.size());
	for (it = ycoord.begin(); it != ycoord.end(); it++){
		fprintf(output_file, "\t%d", *it);
		counter++;
		if (counter == 12){
			fprintf(output_file, "\n");
			counter = 0;
		}
	}

	counter = 0;
	fprintf(output_file, "\n%d\n", (int) acc2D.size());
	for (it = acc2D.begin(); it != acc2D.end(); it++){
		fprintf(output_file, "\t%d", (*it)/2);
		counter++;
		if (counter == 12){
			fprintf(output_file, "\n");
			counter = 0;
		}
	}

	counter = 0;
	fprintf(output_file, "\n%d\n", ((int) proj2D.size())+2);
	for (it = proj2D.begin(); it != proj2D.end(); it++){
		fprintf(output_file, "\t%d", (*it)/2);
		counter++;
		if (counter == 12){
			fprintf(output_file, "\n");
			counter = 0;
		}
	}
	it--;
	it--;
	fprintf(output_file, "\t%d", (*it)/2);
	it++;
	fprintf(output_file, "\t%d", (*it)/2+1);

	counter = 0;
	fprintf(output_file, "\n%d\n", (int) xcoord.size());
	for (it = xcoord.begin(); it != xcoord.end(); it++){
		fprintf(output_file, "\t%d", *it);
		counter++;
		if (counter == 12){
			fprintf(output_file, "\n");
			counter = 0;
		}
	}

	counter = 0;
	fprintf(output_file, "\n%d\n", (int) acc3D.size());
	for (it = acc3D.begin(); it != acc3D.end(); it++){
		fprintf(output_file, "\t%d", (*it)/2);
		counter++;
		if (counter == 12){
			fprintf(output_file, "\n");
			counter = 0;
		}
	}
	fprintf(output_file, "\n");
	return 0;
}
#endif /* WRITE_DTGRDFILE_ASCII_H_ */
