

# Included by the main src/Makefile, all FLAGS / options will be identical
MODTEST_MOD      := test_module

test_force_energy2 : libsda $(OBJ_SDAFLEX) $(MODTEST_MOD)/setup_sda.o $(MODTEST_MOD)/test_force_energy2.o
	$(CC) $(FFLAG) $(LDFLAG) $(OBJ_SDAFLEX) $(MODTEST_MOD)/test_force_energy2.o -o ${BIN}/test_force_energy2 $(MODTEST_MOD)/setup_sda.o read_input_file.f90 prepare_grid.f90 prepare_atom_protein.f90 restart.f90  solva.f90 make_exclusion_grid.f90 init_time.f90 compute_distance.f90 check_exclusion.f90 -B ${LIB} -lsda $(LFLAG)

measure_time_force_energy : libsda $(OBJ_SDAFLEX) $(MODTEST_MOD)/setup_sda.o $(MODTEST_MOD)/measure_time_force_energy.o
	$(CC) $(FFLAG) $(LDFLAG) $(OBJ_SDAFLEX) $(MODTEST_MOD)/measure_time_force_energy.o -o ${BIN}/measure_time_force_energy $(MODTEST_MOD)/setup_sda.o read_input_file.f90 prepare_grid.f90 prepare_atom_protein.f90 restart.f90  solva.f90 make_exclusion_grid.f90 init_time.f90 compute_distance.f90 check_exclusion.f90 ${LIB}/libsda.so $(LFLAG)
	
test_analytic : libsda $(MODTEST_MOD)/test_analytic.o
	$(CC) $(FFLAG) -o ${BIN}/test_analytic $(MODTEST_MOD)/test_analytic.o ${LIB}/libsda.so $(LFLAG)

test_module : test_force_energy2 measure_time_force_energy test_analytic

#clean::
#	rm -f $(MODTEST_MOD)/*.mod $(MODTEST_MOD)/*.o

clean_mod::
	rm -f $(MODTEST_MOD)/*.mod $(MODTEST_MOD)/*.o
