!>  \version{version 7.1 (2015)}
!!
!>  Copyright (c) 2009, 2010, 2015
!>  Heidelberg Institute of Theoretical Studies (HITS, www.h-its.org)
!>        formerly EML Research gGmbH (EML-R )
!>  Schloss-Wolfsbrunnenweg 35
!>  69118 Heidelberg, Germany
!>
!>  Copyright (c) 2000, 2003
!>  European Molecular Biology Laboratory
!>  Meyerhofstr. 1, Postfach 10.2209
!>  D-69012, Heidelberg, Germany 
!>
!>  Please send your contact address to get information on updates and
!>  new features to "mcmsoft@h-its.org". Questions will be
!>  answered as soon as possible.
!>
!>  References (see also http://mcm.h-its.org/sda7/doc/doc_sda7/references.html):
!>
!>  Brownian dynamics simulation of protein-protein diffusional encounter.
!>
!>  (1998) Methods, 14, 329-341.
!>
!> Authors: M.Martinez, N.J.Bruce, J.Romanowska, D.B.Kokh, P.Mereghetti, R.R.Gabdoulline, M. Ozboyaci, S.Richter and R.C.Wade
!>
!>------------------------------------------------------------------------
!<

!> \file ecm_regularize.f90
!!
!! Program ecm_regularize

!> Make the regularization step
!! \ingroup ECM
!!
!! Make the complete iteration\n
!! Then need to call \ref ecm_mkreglev to choose a particluar iteration
program ecm_regularize
    IMPLICIT NONE
    character*128 :: filename
    !integer :: nb_argument

    nb_argument = iargc ()

    if ( nb_argument == 0 ) then
        write(*,*)
        write(*,*) 'HELP'
        write(*,*)
        write(*,*) 'ecm_regularize matrix'
        return
    endif

    call getarg ( 1, filename )

    write(*,*)
    write(*,*) 'input filename ', trim ( filename )

    call sub_regularize ( filename )

end program ecm_regularize

subroutine ecm_regularize
    IMPLICIT NONE


end subroutine ecm_regularize
